//+------------------------------------------------------------------+ 
//| RBCI.mq4 
//| 
//+------------------------------------------------------------------+ 
#property copyright "Copyright 2002, Finware.ru Ltd." 
#property link "http://www.finware.ru/" 

#property indicator_separate_window 
#property indicator_buffers 1 
#property indicator_color1 Blue 

extern int SmoothLength = 5;
extern int SmoothPhase  = 0;


//---- buffers 
double RBCIBuffer[]; 
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() 
{ 
string short_name; 
//---- indicator line 
SetIndexStyle(0,DRAW_LINE); 
SetIndexBuffer(0,RBCIBuffer); 
SetIndexDrawBegin(0,55); 
//---- 
return(0); 
} 
//+------------------------------------------------------------------+ 
//| RBCI | 
//+------------------------------------------------------------------+ 
int start() 
{ 
int i,counted_bars=IndicatorCounted();
double response; 
//---- 
if(Bars<=55) return(0); 
//---- initial zero 
if(counted_bars<55) 
for(i=1;i<=0;i++) RBCIBuffer[Bars-i]=0.0; 
//---- 
i=Bars-55-1; 
if(counted_bars>=55) i=Bars-counted_bars-1; 
while(i>=0) 
{
response= 
-35.5198140000*Close[i+0]
-29.3302904200*Close[i+1]
-18.4253122700*Close[i+2]
-5.3409716410*Close[i+3]
+7.0224246110*Close[i+4]
+16.1743143600*Close[i+5]
+20.6539163900*Close[i+6]
+20.3238589400*Close[i+7]
+16.2679056100*Close[i+8]
+10.3508317200*Close[i+9]
+4.5956464710*Close[i+10]
+0.5816210219*Close[i+11]
-0.9556878591*Close[i+12]
-0.2188650350*Close[i+13]
+1.8617718350*Close[i+14]
+4.0429772970*Close[i+15]
+5.2336026320*Close[i+16]
+4.8503271170*Close[i+17]
+2.9598818100*Close[i+18]
+0.1813422994*Close[i+19]
-2.5916583950*Close[i+20]
-4.5352277420*Close[i+21]
-5.1799911240*Close[i+22]
-4.5414039780*Close[i+23]
-3.0665332280*Close[i+24]
-1.4306935910*Close[i+25]
-0.2740625440*Close[i+26]
+0.0259294264*Close[i+27]
-0.5361336393*Close[i+28]
-1.6274205570*Close[i+29]
-2.7320093940*Close[i+30]
-3.3584444990*Close[i+31]
-3.2210950120*Close[i+32]
-2.3321664220*Close[i+33]
-0.9758039283*Close[i+34]
+0.4132087314*Close[i+35]
+1.4199522360*Close[i+36]
+1.7965291580*Close[i+37]
+1.5408713520*Close[i+38]
+0.8768248011*Close[i+39]
+0.1561692145*Close[i+40]
-0.2796045774*Close[i+41]
-0.2243863077*Close[i+42]
+0.3279264464*Close[i+43]
+1.1886385970*Close[i+44]
+2.0574048450*Close[i+45]
+2.6265630350*Close[i+46]
+2.6969364910*Close[i+47]
+2.2285276520*Close[i+48]
+1.3534844570*Close[i+49]
+0.3088511323*Close[i+50]
-0.6383119873*Close[i+51]
-1.2763116980*Close[i+52]
-1.5134175380*Close[i+53]
-1.3771978870*Close[i+54]
-1.6154244060*Close[i+55];

if (SmoothLength>1)
 RBCIBuffer[i] = iSmooth(response,SmoothLength,SmoothPhase,i);
 else  RBCIBuffer[i] = response;



i--; 
} 
return(0); 
} 
//+------------------------------------------------------------------+ 


double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//


double iSmooth(double price, double length, double phase, int i)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[0][k]=price; for(; k<10; k++) wrk[0][k]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax];
      double del2   = price - wrk[r-1][bsmin];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty] = MathAbs(del2); 
         wrk[r][vsum] =	wrk[r-1][vsum] + (wrk[r][volty]-wrk[r-forBar][volty])*div;
   
         //
         //
         //
         //
         //
   
         wrk[r][avolty] = wrk[r-1][avolty]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum]-wrk[r-1][avolty]);
            if (wrk[r][avolty] > 0)
               double dVolty = wrk[r][volty]/wrk[r][avolty]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax] = price; else wrk[r][bsmax] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin] = price; else wrk[r][bsmin] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0] = price + alpha*(wrk[r-1][0]-price);
         wrk[r][1] = (price - wrk[r][0])*(1-beta) + beta*wrk[r-1][1];
         wrk[r][2] = (wrk[r][0] + R*wrk[r][1]);
         wrk[r][3] = (wrk[r][2] - wrk[r-1][4])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3];
         wrk[r][4] = (wrk[r-1][4] + wrk[r][3]); 

   //
   //
   //
   //
   //

   return(wrk[r][4]);
}

